#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/time.h>
#define MAX 100
// gutenberg.org download books and test them.
/* */prepare a word frequency table for the given text
typedef struct{
	char word[MAX]; //word
	int cnt; //how meny times
} sagedus_t;

typedef struct{
	int max; //current max size
	int n; //the actual number of records
	sagedus_t *M; //a reference to a dynamic array
} dyn_t;

int vordle(const void *, const void *);
void top100(dyn_t );
char *korrasta(char *);
int lisa(dyn_t *, char *);

int main(/*int argc, char **argv*/){
	FILE *f = NULL;
	/*if(argc > 1){
		f = fopen(argv[1], "r"); 
	}*/
	char buf[1000];
	if(f == NULL){
		printf("Enter a file name: ");
		scanf("%999s", buf);
		f = fopen(buf, "r");
	}
	if(f == NULL){
		printf("The file could not be opened.\n");
		return 0;
	}
	dyn_t andmed = {0, 0, NULL}; //variable that whether the addition was successful
	int x; // 
	int wordcount = 0;
	struct timeval start, stop;
	gettimeofday(&start, NULL);
	while(!feof(f)){
		if(fscanf(f, "%99s", buf) == 1)
			x = lisa(&andmed, buf);
		else
			break;  
		if(x == 0){ //adding an accident
			printf("No memory was given.\n");
			break;
		} else
			wordcount++; //how meny words have been read and added
	}
	
	printf("Words together: %d\n", wordcount);
	printf("Unique words: %d\n", andmed.n);
	top100(andmed);	
	gettimeofday(&stop, NULL);
	double aeg = stop.tv_sec +(stop.tv_usec / 1000000.0) -
		( start.tv_sec + start.tv_usec / 1000000.0);
	fclose(f);
	printf("It took %8.3f seconds\n", aeg);
	free(andmed.M);  
	return 0;
}
//comparison function for qsort
int vordle(const void *aa, const void *bb){
	sagedus_t *a = (sagedus_t*)aa, *b = (sagedus_t*)bb;
	return b->cnt - a->cnt;
}
//prints out the 100 most frequent words.
void top100(dyn_t r){
	qsort(r.M, r.n, sizeof(sagedus_t), vordle); //we sort in descending order
	int i;
	for(i = 0; i < r.n && i < 100; i++)
		printf("%s (%d)\n", r.M[i].word, r.M[i].cnt);
}//since the source material is a book, there are many quotation marks, letter spacing, etc.
//they are a distraction and it would be nice to get rid of them

char *korrasta(char *s){
	int x;
	int offset = 0;
	if(strstr(s, "“") != NULL)
		offset = 3;  
	for(x = offset; x < strlen(s); x++)
		if(s[x] == '.' || s[x] == ',' || s[x] == ';' || s[x] == '!')
			s[x] = '\0';  
	return &s[offset];
}
//adds a new word to the array or increases the frequency of an already existing word
int lisa(dyn_t *p, char *ss){
	int i;
	char *s = korrasta(ss);
	for(i = 0; i < p->n; i++)
		if(strcmp(s, p->M[i].word) == 0) //is the new word equal to this word
		{
			p->M[i].cnt++; 
			return 1; 
		}
	//when we get to this place, it is a new word
	int x;  
	void *pointer;  
	if(p->n >= p->max - 1){ // full?
		x = p->max;
		if(x < 10)
			x = 10;
		else
			x = x * 2; //let's increase the array by 2 times
		pointer = realloc(p->M, x * sizeof(sagedus_t));
		if(pointer == NULL){ // no memory
			return 0;  
		}
		p->M = pointer; // new place
		p->max = x;
	}
	p->M[p->n].cnt = 1; //there has been a new word 1 time
	strcpy(p->M[p->n].word, s);
	p->n++;
	return 1;  
}


/*Tirige gutenberg.org lehelt raamatuid ja katsetage neid. ;)
*/
